/****************************************************************************
 *              Copyright 2002, Trustees of Boston University.              *
 *                          All Rights Reserved.                            *
 *                                                                          *
 * Author:      Shudong Jin                                                 *
 ****************************************************************************/


#include <stdlib.h>
#include <math.h>
#include "pareto.h"



/****************************************************************************
 * This routine generates Pareto variate. It is characterized by a scale    *
 * parameter "k", and its shape parameter "a".                              *
 ****************************************************************************/

double pareto_variate(double k, double a)
{
	double	y = drand48();
	return k * exp(-log(1-y)/a);
}

