/***************************************************************************
 *              Copyright 2002, Trustees of Boston University.             *
 *                          All Rights Reserved.                           *
 *                                                                         *
 * Author:      Shudong Jin                                                *
 ***************************************************************************/



#include <math.h>
#include <stdlib.h>
#include "zipf.h"



/***************************************************************************
 * This routine generates zipf-like  distribution. The distribution is     *
 * characterized by "alpha". Here, "N" is the number of objects in the     *
 * distribution.                                                           *
 ***************************************************************************/

int zipf_variate(int N, double alpha)
{
	double	sigma = 0.0;
	double	sum = 0.0;
	int	i;
	double	r = drand48();

	for(i = 0; i < N; i++) {
		sigma += exp(-alpha*log(i+1));
	}

	for(i = 0; i < N; i++) {
		sum += exp(-alpha*log(i+1));
		if (sum / sigma >= r) return(i);
	}
}

